'
' DEVICE.BAS
'
' This program sends the specified string, preceeded and followed
' by a carriage return, to the serial device.
'
' Compile & link: PBCC DEVICE.BAS -ID:\PBCC10\WINAPI
'

$INCLUDE "WIN32API.INC"
$INCLUDE "WSC32.BAS"
$INCLUDE "ERRORS32.BAS"
$INCLUDE "GETARGS.BAS"

FUNCTION PbMain() AS LONG

Dim I As Integer
Dim Code As Long
Dim xPort As Long
Dim Baud As Long
Dim C As String
Dim Argc As Integer
Dim Args(3) As String
Dim StringToSend As String
Dim Buffer As ASCIIZ * 1000
Dim TimeMark As Long

PRINT "DEVICE 9/8/2000 (type ^Z to exit)"

'get command line arguments
Argc = Get3Args(Args(1), Args(2), Args(3))
IF Argc <> 3 THEN
  PRINT "Usage: DEVICE <Port> <Baud> <String>"
  PRINT "Example: DEVICE 1 19200 AT"
  EXIT FUNCTION
END IF

' Get COM port
xPort = VAL(Args(1)) - 1
Baud = VAL(Args(2))
StringToSend = Args(3)

PRINT "Port : COM";LTRIM$(STR$(1+xPort))
PRINT "Baud : ";LTRIM$(STR$(Baud))
PRINT "Text : '";StringToSend;"'"

' open the port (8N1 is default)
Code = SioReset(xPort,1024&,1024&)
IF Code < 0 THEN
  Call SayError(Code)
  EXIT FUNCTION
END IF

'set baud rate
Code = SioBaud(xPort,Baud)
IF Code < 0 THEN
  Call SayError(Code)
  EXIT FUNCTION
END IF

' set DTR & RTS
Code = SioDTR(xPort, ASC("S"))
Code = SioRTS(xPort, ASC("S"))

' send CR
Code = SioPutc(xPort, 13)
' send string
FOR I = 1 to LEN(StringToSend)
  ' sleep 125 ms [necessary for many serial devices]
  Code = SleepEx(125, 0)
  C = MID$(StringToSend,I,1)
  Code = SioPutc(xPort, ASC(C))
NEXT I
' sleep 125 ms then send CR
Code = SleepEx(125, 0)
Code = SioPutc(xPort, 13)

' allow 1.5 seconds for response
TimeMark = SioTimer() + 1500

' get response
WHILE SioTimer() < TimeMark
  ' check RX queue
  Code = SioGetc(xPort)
  ' get character ?
  IF Code > 0 Then
    ' display character
    IF Code = 13 THEN
      PRINT
    ELSEIF Code >= &H20 THEN
      PRINT CHR$(Code);
    END IF
  END IF
WEND

' close the port
Code = SioDone(xPort)
END FUNCTION
