'
' ECHOPORT.BAS
'
' Compile & link: PBCC SIMPLE.BAS -ID:\PBCC10\WINAPI -MT
'
'   where the include specification reference where WINAPI.INC
'   is located on your system.
'
' Echoes characters incoming on COM1 and COM2 using threads.
'
' (1) Connect COM1 and/or COM2 to another computer using a NULL modem cable.
' (2) Start SIMPLE on other computer(s) at 38400 baud.
' (3) Start ECHOPORT. Anything transmitted from remote is echoed back by ECHOPORT.
'
' To terminate ECHOPORT, type ^C or disconnect cables (which drops DSR).
'

$INCLUDE "WSC32.BAS"
$INCLUDE "ERRORS32.BAS"
$INCLUDE "WIN32API.INC"

FUNCTION PbMain() AS LONG

Dim I As Integer
Dim Code As Long
Dim xPort As Long
Dim Result As Long
Dim ThreadID(2) As Long
Dim Counter As Integer
Dim IsRunning(2) As Integer

PRINT "ECHOPORT 9/8/2000 (Type ^Z to exit)"

IF LEN(COMMAND$) > 0 THEN
  PRINT "ECHOPORT takes no arguments!"
  EXIT FUNCTION
END IF
' start 2 threads
FOR I = %COM1 TO %COM2
  THREAD CREATE ComThread(I) TO ThreadID(I)
  Code = SleepEx(100, 0)
NEXT
PRINT "***"
PRINT "*** Type Control-BREAK to terminate main"
PRINT "***"
DO
  Counter = 0
  FOR I = %COM1 TO %COM2
    THREAD STATUS ThreadID(I) TO Result
    'count running thread
    IF Result <> 0 THEN
      Incr Counter
    END IF
  NEXT I
  ' any threads running ?
  IF Counter = 0 THEN
    PRINT "All threads terminated."
    EXIT Function
  END IF
  Code = SleepEx(0, 0)
LOOP

END FUNCTION

FUNCTION ComThread(ByVal xPort As Long) As Long
Dim Code As Long
PRINT "Starting thread for COM";LTRIM$(STR$(xPort+1))
' reset port (8N1 is default)
Code = SioReset(xPort,1024&,1024&)
IF Code < 0 THEN
  Call SayError(Code)
  EXIT FUNCTION
END IF
'set baud rate to 19200
Code = SioBaud(xPort,19200)
IF Code < 0 THEN
  Call SayError(Code)
  EXIT FUNCTION
END IF
' set DTR & RTS
Code = SioDTR(xPort,ASC("S"))
Code = SioRTS(xPort,ASC("S"))
Code = SleepEx(100, 0)
PRINT "Online for COM";xPort+1
DO
  ' this thread is done when DSR is dropped
  IF SioDSR(xPort) = 0 THEN
    PRINT "COM";LTRIM$(STR$(xPort+1));" DSR dropped, aborting thread."
    Code = SioDone(xPort)
    EXIT FUNCTION
  END IF
  ' anything incoming ?
  Code = SioGetc(xPort)
  IF Code = 13 THEN
    PRINT
  ELSEIF Code >= &H20 THEN
    PRINT CHR$(Code);
  END IF
  ' give up rest of time slice
  Code = SleepEx(0, 0)
LOOP
END FUNCTION
