'
' THREAD.BAS
'
' Compile & link: PBCC THREAD.BAS -ID:\PBCC10\WINAPI -MT
'   where the include specification reference where WINAPI.INC
'   is located on your system.
'

$INCLUDE "WSC32.BAS"
$INCLUDE "ERRORS32.BAS"
$INCLUDE "WIN32API.INC"

FUNCTION PbMain() AS LONG

Dim I As Integer
Dim Code As Long
Dim xPort As Long
Dim Baud AS Long
Dim Arg1 As String
Dim Arg2 As String
Dim Parms As String
Dim Version As Integer
Dim A As String
Dim B As String
Dim C As String
Dim ThreadID As Long

PRINT "THREAD 9/7/2000 (Type ^Z to exit)"

' display WSC version
Version = SioInfo(ASC("V"))
C = Hex$(&HF And Version)
Version = Version / 16
B = Hex$(&HF And Version)
Version = Version / 16
A = Hex$(&HF And Version)
PRINT "WSC Version " + A + "." + B + "." + C

'get command line arguments
PARMS$ = RTRIM$(COMMAND$)
I = INSTR(PARMS$, " ")
IF I < 1 THEN
  PRINT "  Usage: THREAD <Port> <BaudRate>"
  PRINT "Example: THREAD 1 9600"
  EXIT FUNCTION
END IF
ARG1$ = LEFT$(PARMS$, I - 1)
ARG2$ = LTRIM$(RIGHT$(PARMS$, LEN(PARMS$) - I))

'Get COM port
xPort = VAL(ARG1$) - 1
Baud = VAL(ARG2$)
'''PRINT "COM";1+xPort;" @";Baud

'reset port (8N1 is default)
Code = SioReset(xPort,1024&,1024&)
IF Code < 0 THEN
  Call SayError(Code)
  EXIT FUNCTION
END IF

'set baud rate
Code = SioBaud(xPort,Baud)
IF Code < 0 THEN
  Call SayError(Code)
  EXIT FUNCTION
END IF

' set DTR & RTS
Code = SioDTR(xPort,ASC("S"))
Code = SioRTS(xPort,ASC("S"))

THREAD CREATE ComThread(xPort) TO ThreadID

' enter terminal loop
DO
  'Anything to send ?
  AnyKey$ = INKEY$
  IF AnyKey$ <> "" THEN
    'Exit if user types Control-Z or ESC
    IF AnyKey$ = CHR$(26) THEN EXIT DO
    IF AnyKey$ = CHR$(27) THEN EXIT DO
    Code = SioPutc(xPort,ASC(AnyKey$))
  END IF
LOOP
Code = SioDone(xPort)
END FUNCTION

FUNCTION ComThread(ByVal xPort As Long) As Long
Dim I As Long
Dim Code As Long
Dim C As String
Dim Buffer As ASCIIZ * 1000
PRINT "Starting thread for COM";LTRIM$(STR$(xPort+1))
DO
  ' block for new input
  Code = SioEvent(xPort, %EV_RXCHAR)
  ' get incoming [we are now unblocked]
  Code = SioGets(xPort, Buffer, 1000)
  IF Code > 0 THEN
    ' display each character
    FOR I = 1 TO Code
      C = MID$(Buffer, I, 1)
      IF ASC(C) = 13 THEN
        PRINT
      ELSEIF ASC(C) >= &H20 THEN
        PRINT C;
      END IF
    NEXT I
  END IF
LOOP
END FUNCTION
